# Examples
This folder consist of simple examples showing how to use different `TypeGraphQL` features and how well it integrates with 3rd party libraries.

## Basics
- [simple usage of fields, basic types and resolvers](./simple-usage)

## Features usage
- [dependency injection (IoC containers)](./using-container)
- [authorization](./authorization)
- [validation](./automatic-validation)
- [interfaces and inheritance](./interfaces-inheritance)
- [enums and unions](./enums-and-unions)
- [subscriptions (simple)](./simple-subscriptions)
- [subscriptions (using Redis)](./redis-subscriptions)

## 3rd party libs integration
- [TypeORM (manual, synchronous)](./typeorm-basic-usage)
- [TypeORM (automatic, lazy relations)](./typeorm-lazy-relations)

_* Note that you need to edit the TypeORM examples `index.ts` with credentials to your local database_
